#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#define READ 0
#define WRITE 1

// omg thanks
// https://stackoverflow.com/a/12788169/10719432
pid_t popen2(char* const *command, int *infp, int *outfp) {
  int p_stdin[2], p_stdout[2];
  pid_t pid;

  if (pipe(p_stdin) != 0 || pipe(p_stdout) != 0) return -1;

  pid = fork();

  if (pid < 0) return pid;
  else if (pid == 0) {
    close(p_stdin[WRITE]);
    dup2(p_stdin[READ], READ);
    close(p_stdout[READ]);
    dup2(p_stdout[WRITE], WRITE);

    execvp(command[0], command);
    exit(1);
  }

  if (infp == NULL) close(p_stdin[WRITE]);
  else *infp = p_stdin[WRITE];

  if (outfp == NULL) close(p_stdout[READ]);
  else *outfp = p_stdout[READ];

  return pid;
}
